/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */



#include "Wiconnect.h"
#include "types/PinIrqHandler.h"



/*************************************************************************************************/
PinIrqHandler::PinIrqHandler(PinName irqPin_, const Callback &callback_) : InterruptIn(irqPin_)
{
    irqPin = irqPin_;
    callback = callback_;
    mode(PullDown);
    rise(this, &PinIrqHandler::irqHandler);
    enable_irq();
}

/*************************************************************************************************/
PinIrqHandler::~PinIrqHandler()
{
    disable_irq();
}


/*************************************************************************************************/
void PinIrqHandler::irqHandler()
{
    callback.call(WICONNECT_SUCCESS, (void*)irqPin, NULL);
}
