/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once


#include "Wiconnect.h"
#include "types/File.h"

namespace wiconnect
{

class FileList
{
public:
    FileList(int bufferLen = 0, void *buffer = NULL);
    ~FileList();

    const File* getListHead() const;
    int getCount() const;
    const File* getResult(int i) const;
    const File* operator [](int i) const;

protected:
    File *listHead, *listTail;
    uint8_t *buffer;
    uint8_t *bufferPtr;
    int bufferLen;
    int count;

    WiconnectResult add(const char *typeStr, const char *flagsStr, const char* sizeStr, const char *versionStr, const char *nameStr);

    friend class FileInterface;
};


}
