/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once



#include "WiconnectTypes.h"
#include "StringUtil.h"


namespace wiconnect
{


class ScanResult
{
public:
    uint8_t getChannel() const;
    NetworkSignalStrength getSignalStrength() const;
    const MacAddress* getMacAddress() const;
    NetworkSecurity getSecurityType() const;
    uint32_t getRate() const;
    const char* getRateStr(char *buffer = NULL) const;
    const Ssid* getSsid() const;

    const ScanResult* getNext() const;
    const ScanResult* getPrevious() const;

protected:
    ScanResult();

    WiconnectResult init(const char *channelStr, const char *rssiStr, const char* macStr, const char *rateStr, const char *secStr, const char *ssidStr);
    ScanResult *next;
    ScanResult *previous;
    uint8_t channel;
    int16_t rssi;
    MacAddress mac;
    uint32_t rate;
    NetworkSecurity security;
    Ssid ssid;

    void* operator new(size_t size);
    void operator delete(void*);

    friend class ScanResultList;
};






}
