/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once

#include "WiconnectTypes.h"
#include "types/ScanResult.h"



namespace wiconnect
{



class ScanResultList
{
public:
    ScanResultList(int bufferLen = 0, void *buffer = NULL);
    ~ScanResultList();

    const ScanResult* getListHead() const;
    int getCount() const;
    const ScanResult* getResult(int i) const;
    const ScanResult* operator [](int i) const;

protected:
    ScanResult *listHead, *listTail;
    uint8_t *buffer;
    uint8_t *bufferPtr;
    int bufferLen;
    int count;

    WiconnectResult add(const char *channelStr, const char *rssiStr, const char* macStr, const char *rateStr, const char *secStr, const char *ssidStr);


    friend class NetworkInterface;
};


}
