/*
 * Copyright 2014, ACKme Networks
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of ACKme Networks;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of ACKme Networks.
 */

#pragma once

#include "WiconnectTypes.h"


namespace wiconnect
{

class WiconnectSerial WICONNECT_SERIAL_BASE_CLASS
{
public:
    WiconnectSerial(const SerialConfig  &config, Wiconnect *wiconnect = NULL);
    virtual ~WiconnectSerial();

    void flush(void);
    int write(const void *data, int bytesToWrite, int timeoutMs);
    int read(void *data, int bytesToRead, int timeoutMs);

protected:
    TimeoutTimer timeoutTimer;
#ifdef WICONNECT_SERIAL_RX_BUFFER
    uint8_t ringBuffer[32];
    bool bufferAlloc;
    void rxIrqHandler(void);
#endif
};


}


